from tinyos.tossim.TossimApp import *;
import TOSSIM;
import os, sys, time,commands

def usage():
	print "usage: python Flood.py <options> <NUMBER OF NODES>\n"
	print "Options:\n"
	print "-i      \t The input topo gain file";
	print "-o      \t The output trace file";
	print "-ttl 	\t The node from which the random walk will start"
	print "-start_node 	\t The node from which flood starts"

#input arguments for the Flood.py file
if (len(sys.argv) < 2):
	usage();
	sys.exit();

#TRACEFILE="trace.txt";
#INPUTFILE="topo_gain.txt";

#if (len(sys.argv) < 3):
#	print "Usage: python Flood.py <NUM SIM NODES> <TTL>"
#	sys.exit();

START_TIMER = 0; 	# JA
START_NODE = 0;
#TTL = int(sys.argv[2]);
TTL = 255;			#JA

i = 1;
while (i < len(sys.argv) - 1):
	if (sys.argv[i] == "-o"):
		i= i + 1;
		TRACEFILE=sys.argv[i];
	elif (sys.argv[i] == "-i"):
		i= i + 1;
		INPUTFILE=sys.argv[i];
	elif (sys.argv[i] == "-ttl"):
		i = i + 1;
		TTL = int(sys.argv[i]);
	elif (sys.argv[i] == "-start_node"):
		i = i + 1;
		START_NODE = int(sys.argv[i]);
	else:
		usage();
		sys.exit(1);
	i = i + 1;

NUM_SIM_NODES = int(sys.argv[len(sys.argv) - 1]);

print "Using input file "+INPUTFILE+"....."
print "Outputting trace file "+TRACEFILE+"....."
print "Flooding TTL set to "+str(TTL)+"....."
print "Number of nodes being simulated are "+ str(NUM_SIM_NODES) +" ....."
print "Start node for flooding is "+ str(START_NODE) +" ....."

#definition of type of packets.
NEIGHBOR_INFO = 20;
END_NEIGHBOR_INFO = 21;
ADOPT_NEIGHBOR = 22;
ADOPT_NEIGHBOR_ACK = 23;
START_FLOOD = 24;
FORWARD_FLOOD = 25;

#definition of operations of floods
FLOOD_OP_NOP = 0
FLOOD_OP_SYNC_LOG = 1

try:
	trace_file = open(TRACEFILE,"w");
except :
	print "ERROR: Unable to open the trace file "+TRACEFILE
	sys.exit(1);

try:
	f_topo_gain = open(INPUTFILE,"r");
except:
	print "ERROR: Unable to open the link gains input file "+INPUTFILE
	print " please check the path and file name."
	sys.exit(1);

n = NescApp("Flood");
sim_obj = TOSSIM.Tossim(n.variables.variables());
#sim_obj = TOSSIM.Tossim([]);
sim_mac = sim_obj.mac();
sim_radio = sim_obj.radio();

sim_obj.init();

#trace_file = open("trace.txt","w");

sim_obj.addChannel("FLOOD", trace_file);
sim_obj.addChannel("FLOOD",sys.stdout);

sim_obj.addChannel("LOG", trace_file);
sim_obj.addChannel("LOG",sys.stdout);

sim_obj.addChannel("ERROR", sys.stdout );

#
# JA: Making sure every node in the network is on.
for i in range(0, NUM_SIM_NODES):
	node = sim_obj.getNode(i);
	node.bootAtTime(sim_obj.time() + i*10000);
	while True:
		sim_obj.runNextEvent();
		if node.isOn() :
			print "Completed booting node "+str(i)
			break


#create links between nodes
#f_topo_gain = open("topo_gain.txt","r");

prr_matrix = [None] * NUM_SIM_NODES;
for i in range(NUM_SIM_NODES):
	prr_matrix[i] = [None] * NUM_SIM_NODES;


for line in f_topo_gain:
		s = line.split();
		if (len(s)>0):
			if (s[0] == "gain"):
				sim_radio.add(int(s[1]), int(s[2]), float(s[3]));
			if (s[0] == "noise"):
				sim_radio.setNoise(int(s[1]),float(s[2]),2);
			if (s[0] == "prr"):
				prr_matrix[int(s[1])][int(s[2])] = float(s[3]);
			if (s[0] == "coord"):
				x = 1

execfile("FloodMsg.py");
#Create the flood message packet and the
#simulation packet to be sent.

#for each of the nodes generate the link metric and
#send out the packet for that node to add the end
#node of that link as a neighbor.
#	for i in range(0, NUM_SIM_NODES):
#		for j in range(0, NUM_SIM_NODES):
#			if ( i != j):
#				#print str(prr_matrix[i][j])+" "+str(prr_matrix[j][i]);
#				if (prr_matrix[i][j] > 0 and prr_matrix[j][i] > 0):
#					#create a packet and send it to the node.
#	                                #print "creating packet";
#					#print str(i)+" "+str(j);
#					flood_start_msg.set_dest(i);
#					flood_start_msg.set_src(j);
#					flood_start_msg.set_top(NEIGHBOR_INFO);
#					flood_start_msg.set_inPRR(100*prr_matrix[j][i]);
#					flood_start_msg.set_outPRR(100*prr_matrix[i][j]);
#					pkt.setData(flood_start_msg.data);
#					pkt.setType(flood_start_msg.get_amType());
#					pkt.setDestination(i);
#					pkt.deliverNow(i);
#					#run the events till we have delivered the packet.
#					for k in range (0, 100):
#						sim_obj.runNextEvent();





#print "Completed booting up of nodes.\n"
#	print "Neighbor setup done.\n"
#execfile('RWMsg.py')



#check the AM_TYPE of the message
#print "AM type of message :"+ rw_start_msg.get_amType()
#print "Creating a packet.\n"

#	for i in range(0, NUM_SIM_NODES):
#		flood_start_msg.set_dest(i);
#		flood_start_msg.set_top(END_NEIGHBOR_INFO);
#		flood_start_msg.set_numNodes(NUM_SIM_NODES);
#		pkt.setData(flood_start_msg.data);
#		pkt.setType(flood_start_msg.get_amType());
#		pkt.setDestination(i);
#		pkt.deliverNow(i)
#		for k in range (0, 5000):
#			sim_obj.runNextEvent();

#	print "Done with artificial END_NEIGHBOR_INFO events\n"
#print "Signalling end of neighbor info\n"

#sim_obj.addChannel("Gain",sys.stdout);
#sim_obj.addChannel("Gain",trace_file);

#	Start Flooding
flood_pkt_num = 1000;
for i in range(flood_pkt_num):
	flood_start_msg = FloodMsg();
	pkt = sim_obj.newPacket();
	flood_start_msg.set_id( i+1 );
	flood_start_msg.set_src( START_NODE );
	flood_start_msg.set_dest(START_NODE);
	flood_start_msg.set_top(START_FLOOD);
	flood_start_msg.set_op( FLOOD_OP_NOP );
	flood_start_msg.set_ttl(TTL);
	flood_start_msg.set_numNodes(NUM_SIM_NODES);
	pkt.setData(flood_start_msg.data);
	pkt.setType(flood_start_msg.get_amType());
	pkt.setDestination(START_NODE);
	pkt.deliver(START_NODE, sim_obj.time()+300001 + (i*10000000000))

# for the last flooding packet for log synchronization.
flood_start_msg = FloodMsg();
pkt = sim_obj.newPacket();
flood_start_msg.set_id( flood_pkt_num + 1 );
flood_start_msg.set_src( START_NODE );
flood_start_msg.set_dest(START_NODE);
flood_start_msg.set_top(START_FLOOD);
flood_start_msg.set_op( FLOOD_OP_SYNC_LOG );
flood_start_msg.set_ttl(TTL);
flood_start_msg.set_numNodes(NUM_SIM_NODES);
pkt.setData(flood_start_msg.data);
pkt.setType(flood_start_msg.get_amType());
pkt.setDestination(START_NODE);
pkt.deliver(START_NODE, sim_obj.time()+300001 + (flood_pkt_num*10000000000))


print repr( flood_pkt_num + 1 ) + " START_FLOOD packet(s) sent!\n"

#print "Signalling end of neighbor info\n"

t1 = time.clock()
commandString = 'cat ' + TRACEFILE + '|wc -l'
(x, y) = commands.getstatusoutput(commandString)
prevy = y

#sim_obj.addChannel("Gain",sys.stdout);
while True:
	t2 = time.clock()
	if (t2 - t1 > 2):
		(x, y) = commands.getstatusoutput(commandString)
		if (prevy == y):
			print "y value is " + str(y)
			sys.exit()
		else:
			prevy = y
			t1 = time.clock()
	if ( not sim_obj.runNextEvent() ):
		break;

