/*
 * "Copyright (c) 2006 University of Southern California. All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose, without fee, and without written
 * agreement is hereby granted, provided that the above copyright
 * notice, the following two paragraphs and the author appear in all
 * copies of this software.
 *
 * IN NO EVENT SHALL UNIVERSITY OF SOUTHERN CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF UNIVERSITY OF SOUTHERN CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * UNIVERSITY OF SOUTHERN CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND UNIVERSITY OF SOUTHERN CALIFORNIA
 * HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 * ENHANCEMENTS, OR MODIFICATIONS."
 */

/*
 * Data structures used for flooding application
 * ==============================
 * @auth Joon Ahn <joonahn@usc.edu>
*/

#ifndef FLOODDATASTRUCT_H_ALJKDFHLEUWI7E28379238508432		// JA
#define FLOODDATASTRUCT_H_ALJKDFHLEUWI7E28379238508432	// JA


//#define TIMEOUT 1250
//#define NEIGHBOR_TIMEOUT 1
//#define MAX_NEIGHBORS 50		// JA

typedef struct FloodPktStruct {
	nx_uint16_t	id;			// JA: flood id		--	zero means dummy
	nx_uint16_t src;			// NOTICE: number of floods to do experiments when op is FLOOD_OP_BEGIN_EXPERIMENT
	nx_uint16_t dest;
	nx_uint8_t top;
	nx_uint8_t op;			// operation
	nx_uint8_t ttl;
	nx_uint8_t power;
} FloodPktStruct;

enum {
	AM_FLOODPKTSTRUCT=4
};

enum {
  START_TIMER = 0,
  TEST_PKT = 1,		// probes to test links
  PRR_PKT = 2,		// send prr of link
  TX_DATA_TO_PC = 3,	// send logged data to PC
  PRR_BS_PKT = 10,
  REFRESH_MOTE_MEMORY = 12,
  RESET_MSG = 13,
  NEIGHBOR_INFO = 20,
  END_NEIGHBOR_INFO = 21,
  ADOPT_NEIGHBOR = 22,
  ADOPT_NEIGHBOR_ACK = 23,
  START_FLOOD = 24,
  FORWARD_FLOOD = 25
};

enum operations {
	FLOOD_OP_NOP = 0,			// no operation
	FLOOD_OP_SYNC_LOG = 1,
	FLOOD_OP_ERASE_LOG = 2,
	FLOOD_OP_BEGIN_EXPERIMENT = 3	// not yet ready. don't use this	// only applied to START_FLOOD and "src" will be experiment number.
};


#if 0
enum {
  PRR_THRESHOLD = 99
};

 enum {
    maxdata = 8			// Circular buffer size
};
 #endif


#endif   	// FLOODDATASTRUCT_H_ALJKDFHLEUWI7E28379238508432


