/*
 * "Copyright (c) 2006 University of Southern California. All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose, without fee, and without written
 * agreement is hereby granted, provided that the above copyright
 * notice, the following two paragraphs and the author appear in all
 * copies of this software.
 *
 * IN NO EVENT SHALL UNIVERSITY OF SOUTHERN CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF UNIVERSITY OF SOUTHERN CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * UNIVERSITY OF SOUTHERN CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND UNIVERSITY OF SOUTHERN CALIFORNIA
 * HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 * ENHANCEMENTS, OR MODIFICATIONS."
 */

/*
 *	JaLogFloodTypes
 *
 *	@author	Joon Ahn <joonahn@usc.edu>
 *	@date 	08.18.2006
 *
 */

#ifndef JADUMPPACKET_H_ALUJGHE82984024924
#define JADUMPPACKET_H_ALUJGHE82984024924

#include "AM.h"

typedef struct __jadumppkt_t
{
	nx_am_addr_t		src;				// source address (or ID)
	nx_uint8_t		op;				// operation
	nx_uint8_t		size;			// in bytes
	nx_uint8_t		seqno;			// sequence number
	nx_uint8_t		data[1];			// the first byte of the data
} jadumppkt_t;


enum
{
	AM___JADUMPPKT_T = 8,
	AM_DUMPPKT_T = AM___JADUMPPKT_T
};

#endif // JADUMPPACKET_H_ALUJGHE82984024924

