/*
 * "Copyright (c) 2006 University of Southern California. All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose, without fee, and without written
 * agreement is hereby granted, provided that the above copyright
 * notice, the following two paragraphs and the author appear in all
 * copies of this software.
 *
 * IN NO EVENT SHALL UNIVERSITY OF SOUTHERN CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF UNIVERSITY OF SOUTHERN CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * UNIVERSITY OF SOUTHERN CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND UNIVERSITY OF SOUTHERN CALIFORNIA
 * HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 * ENHANCEMENTS, OR MODIFICATIONS."
 */

/*
 *	Main Definition Files
 *
 *	@author	Joon Ahn <joonahn@usc.edu>
 *	@date 	08.26.2006
 *
 */

#ifndef MAINDEFS_H_JGFQULEWU98237592
#define MAINDEFS_H_JGFQULEWU98237592


//////////////////////////////////////////////////////////////////////////////
// COMPILATION OPTIONS

#define JADEBUG								1
#define DEBUG_Q								1		// for JaQueuedLoggerP
#define ENABLE_DELAYED_FLOODING 			1
#define ENABLE_BLINK_AFTER_FLOODING		1
#define ENABLE_QLOGGER_TIMER				1


//////////////////////////////////////////////////////////////////////////////
// CONSTANTS and DEFINITIONS

#define BASIC_FLOOD_STARTING_ID			TOS_NODE_ID * 100

enum
{
	BASIC_FLOOD_POWER = 2,
	LOGGER_QUEUE_SIZE = 30
};


////////////////////////////////////////////////////////////////////////////
// UTILITIES

// For debugging.
#ifdef TOSSIM

#define DBGERR( s, ... )	dbgerror( "Error (%s,%d): " s, __FILE__, __LINE__, __VA_ARGS__ )

#else

#define DBGERR( s, ... )

#endif

#endif // MAINDEFS_H_JGFQULEWU98237592

